package com.loafle.overflow.core.json;

import java.io.IOException;
import java.util.List;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;
import com.loafle.overflow.model.infra.InfraHostIP;

/**
 * InfraHostIPsSerializer
 */
public class InfraHostIPsSerializer extends StdSerializer<List<InfraHostIP>> {

  private static final long serialVersionUID = -7842189644539038488L;

  public InfraHostIPsSerializer() {
    this(null);
  }

  public InfraHostIPsSerializer(Class<List<InfraHostIP>> t) {
    super(t);
  }

  @Override
  public void serialize(List<InfraHostIP> infraHostIPs, JsonGenerator gen, SerializerProvider provider)
      throws IOException {
    if (null != infraHostIPs) {
      for (InfraHostIP infraHostIP : infraHostIPs) {
        infraHostIP.setInfraHost(null);
      }
    }

    gen.writeObject(infraHostIPs);
  }

}