package com.loafle.overflow.service.central.infra;

import java.util.List;

import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.discovery.Host;
import com.loafle.overflow.model.discovery.Service;
import com.loafle.overflow.model.discovery.Zone;
import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.model.infra.InfraHost;
import com.loafle.overflow.model.infra.InfraZone;

import org.springframework.data.domain.Page;

/**
 * Created by insanity on 17. 6. 28.
 */
public interface InfraService {

  @WebappAPI
  Infra regist(Infra infra) throws OverflowException;

  @WebappAPI
  InfraZone registByZone(Long probeID, Zone zone) throws OverflowException;

  @WebappAPI
  InfraHost registByHost(Long probeID, Host host) throws OverflowException;

  @WebappAPI
  com.loafle.overflow.model.infra.InfraService registByService(Long probeID, Service service) throws OverflowException;

  @WebappAPI
  List<Infra> registDiscoverd(Long probeID, List<Host> hosts, List<Service> services) throws OverflowException;

  @WebappAPI
  Infra read(Long id) throws OverflowException;

  @WebappAPI
  Page<Infra> readAllByProbeID(Long probeID, PageParams pageParams) throws OverflowException;

  @WebappAPI
  List<Infra> readAllInfraByProbeID(Long probeID) throws OverflowException;

  @WebappAPI
  Page<Infra> readAllByDomainID(Long domainID, PageParams pageParams) throws OverflowException;

  @WebappAPI
  List<Infra> readAllInfraByDomainID(Long domainID) throws OverflowException;

  @WebappAPI
  List<InfraZone> readAllInfraZoneByProbeDomainID(Long probeDomainID) throws OverflowException;

  @WebappAPI
  List<Infra> readAllByMetaInfraTypeKeyAndProbeID(String metaInfraTypeKey, Long probeID) throws OverflowException;

}
